<?php

/**
 * inf_estado_proceso_cobrocoactivo  actions.
 *
 * @package    CobroCoactivo
 * @subpackage inf_estado_proceso_cobrocoactivo
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_estado_proceso_cobrocoactivoActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = '  ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //Codigo Titulo
            if (isset($request['cod_titulo'])) {
                $whereCodTitulo = " AND tab0.cod_titulo = " . $request['cod_titulo'];
            } else {
                $whereCodTitulo = ' ';
            }
            //id abogado
            if (isset($request['id_abogado'])) {
                $whereIdAbogado = " AND tab0.id_abogado = " . $request['id_abogado'];
            } else {
                $whereIdAbogado = ' ';
            }
            //id anhos
            if(isset($request['id_anhos'])){
                $whereAnho = 'AND tab0.id_anhos = '.$request['id_anhos'];
            } else {
                $whereAnho = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             *
             */
            $consulta_sql = <<<EOD
select
tab0.*
from(
                    
 select
  tab0.id_remision_titulo,
  tab0.cod_titulo,
  tab0.anho_remision as id_anhos,
  to_char(tab0.fecha_remision,'dd/mm/yyyy') as fecha_remision,
  crt.no_resolucion as REGISTRO_RESOLUCION,
  condeu.DESCRIPCION as CONCEPTO_DEUDA,
  tab4.id_abogado,
  tab5.RAZON_SOC as REPARTO_ABOGADO,
  cad.aprobado as aprobado_deneg,
  cac.no_auto as no_auto_avoca,
  cod.no_oficio as NO_OFICIO_SALIDA_DEUDOR,
  cod.no_oficio,                    
  cib.no_oficio as NO_OFICIO_INVESTIGA_BIENES,
  tab7.no_auto as no_auto_cierre,
  cpc.FECHA as fecha_cobro_coactivo,
  cafp.NO_RESOLUCION as NO_RESOLUCION_APRUEBA_FP,

  to_char(tab6.fecha_cierre) as fecha_cierre_persua,
  tab6.estado as estado_cierre_persua,
  tab6.adjunto as adjunto_cierre_persua,
  tab6.observaciones as observ_cierre_persua,
  to_char(tab7.fecha) as fecha_auto_cierre,
  cpc.ID_PROCESO_COACTIVO,
  cpc.NO_PROCESO as NO_PROCESO_COACTIVO,
  cpc.no_proceso,                    
  cad.fecha as fecha_aprob_deneg

  from cbr_remision_titulo tab0
  left join CBR_RESOLUCION_TIT crt on crt.cod_titulo = tab0.cod_titulo
  left join CBR_REGISTRO_CONCEPTO crconcepto on crconcepto.id_resolucion_tit = crt.id_resolucion_tit
  left join CBR_CONCEPTO_DEUDA condeu on condeu.id_concepto_deuda = crconcepto.id_concepto_deuda
  left join cbr_aprueba_reparto tab2 on tab2.id_remision_titulo = tab0.id_remision_titulo
  left join cbr_reparto tab3 on tab3.id_remision_titulo = tab2.id_remision_titulo
  left join cbr_abogado tab4 on tab4.id_abogado = tab3.id_abogado
  left join interceros tab5 on tab5.id_mae_ter = tab4.id_mae_ter
  left join cbr_cierre_persuasivo tab6 on tab6.id_remision_titulo = tab0.id_remision_titulo
  left join cbr_auto_cierre tab7 on tab7.id_remision_titulo = tab6.id_remision_titulo
  join cbr_avoca_conoc cac on cac.id_remision_titulo = tab0.id_remision_titulo
  left join cbr_aprob_deneg cad on cad.ID_REMISION_TITULO=tab0.ID_REMISION_TITULO
  left join cbr_oficio_deudor cod on cod.id_remision_titulo = cac.id_remision_titulo
  left join cbr_investiga_bienes cib on cib.id_remision_titulo = cod.id_remision_titulo
  left join cbr_cierre_persuasivo ccp on ccp.id_remision_titulo = cac.id_remision_titulo
  join CBR_PROCESO_COACTIVO cpc on cpc.ID_REMISION_TITULO=tab0.ID_REMISION_TITULO
  left join cbr_facilidad_pago cfp on cfp.id_proceso_coactivo=cpc.id_proceso_coactivo
  left join cbr_aprueba_fp cafp on cafp.id_facilidad_pago = cfp.id_facilidad_pago

where tab0.fecha_remision between to_date( '$fecha_ini', 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )



)tab0
                    
where
1 = 1 
$whereIdAbogado                    
$whereCodTitulo
$whereAnho                    
     
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_estado_proceso_cobrocoactivo] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
